import { BindingObserver, ExecutionContext } from '@microsoft/fast-element';
/**
 * @typeParam TReturn - The return type.
 * @param value - The bound value.
 * @param args - A binding observer.
 * @internal
 */
export type SubscriberChangeCallback<TReturn = any> = (value: TReturn, args: BindingObserver) => void;
/**
 * @typeParam TTarget - The target interface.
 * @typeParam TReturn - The return type.
 * @param binding - A binding.
 * @param args - A binding observer.
 * @internal
 */
export type SubscriberChangeHandler<TTarget = any, TReturn = any> = (binding: (x?: TTarget, context?: ExecutionContext) => TReturn, args: BindingObserver) => void;
/**
 * @typeParam TTarget - The target interface.
 * @typeParam TReturn - The return type.
 * @internal
 */
export interface TargetSubscriber<TTarget = any, TReturn = any> {
    handleChange: SubscriberChangeHandler<TTarget, TReturn>;
}
/**
 * @typeParam TTarget - The target interface.
 * @param target - The target.
 * @internal
 */
export type TargetBinding<TTarget = any> = (target: TTarget) => any;
/**
 * @typeParam TTarget - The target interface.
 * @param args - Binding args.
 * @internal
 */
export declare const getBindArgs: <TTarget = any>(...args: unknown[]) => TargetBinding<TTarget>;
//# sourceMappingURL=binding.d.ts.map