import { Message } from '@genesislcap/foundation-comms';
/**
 * GenesisServerError.
 * @remarks
 * Represents an error received from a Genesis Server.
 * @public
 */
export declare class GenesisServerError extends Error {
    sent?: Message;
    received?: Message;
    constructor(sent?: Message, received?: Message, message?: string);
    /**
     * Capture known edge cases.
     * @privateRemarks
     * This is ugly, lets figure out if this is still an issue and remove if not.
     */
    isIgnorableError(): boolean;
    getMessageError(): string;
    getDetailsError(): string;
    hasErrorCode(code: string): boolean;
    private errorDetailFormatter;
}
/**
 * @param error - An error.
 * @public
 */
export declare const isGenesisServerError: (error: unknown) => error is GenesisServerError;
/**
 * MappingError.
 * @public
 */
export declare class MappingError extends Error {
    dto?: unknown;
    constructor(dto?: unknown, message?: string);
}
/**
 * @param error - An error.
 * @public
 */
export declare const isMappingError: (error: unknown) => error is MappingError;
//# sourceMappingURL=errors.d.ts.map