import { AnyEventObject, DoneInvokeEvent, ErrorEvent, EventObject, ParameterizedObject } from 'xstate';
/**
 * assertEvent.
 * @privateRemarks
 * Note `asserts` need to be functions to work.
 * @param event - An event.
 * @param type - An event type.
 * @public
 */
export declare function assertEvent<TEvent extends EventObject = EventObject>(event: TEvent, type: TEvent['type']): asserts event is Extract<TEvent, {
    type: TEvent['type'];
}>;
/**
 * isDoneInvokeEvent.
 * @param event - An event.
 * @public
 */
export declare const isDoneInvokeEvent: <TData = any>(event: EventObject | DoneInvokeEvent<TData>) => event is DoneInvokeEvent<TData>;
/**
 * isErrorEvent.
 * @param event - An event.
 * @public
 */
export declare const isErrorEvent: <TData = any>(event: EventObject | ErrorEvent<TData>) => event is ErrorEvent<TData>;
/**
 * isErrorCustomEvent.
 * @remarks
 * What `escalate` from a child is typed as.
 * @param event - An event.
 * @public
 */
export declare const isErrorCustomEvent: <TData = any>(event: EventObject | ErrorEvent<TData>) => event is ErrorEvent<TData>;
/**
 * isActorErrorEvent.
 * @param actorId - An actor id.
 * @param event - An event.
 * @public
 */
export declare const isActorErrorEvent: <TData = any>(actorId: string, event: EventObject | ErrorEvent<TData>) => event is ErrorEvent<TData>;
/**
 * isEventWithParams.
 * @param event - An event.
 * @public
 */
export declare const isEventWithParams: (event: AnyEventObject) => event is ParameterizedObject;
/**
 * isErrorType.
 * @param type - An event type.
 * @public
 */
export declare const isErrorType: <TType extends ErrorConstructor>(type: TType) => (event: any) => boolean;
/**
 * isTypeError.
 * @public
 */
export declare const isTypeError: ({ event }: {
    event: any;
}) => boolean;
/**
 * isSyntaxError.
 * @public
 */
export declare const isSyntaxError: ({ event }: {
    event: any;
}) => boolean;
/**
 * isAbortError.
 * @public
 */
export declare const isAbortError: ({ event }: {
    event: any;
}) => boolean;
//# sourceMappingURL=guards.d.ts.map