/**
 * @typeParam TTarget - The target interface.
 * @param args - Binding args.
 * @internal
 */
export const getBindArgs = (...args) => {
    const [token] = args;
    let binding = (x) => x;
    if (typeof token === 'function') {
        binding = token;
    }
    else if (typeof token === 'string') {
        binding = (x) => x[token];
    }
    return binding;
};
