## API Report File for "@genesislcap/foundation-state-machine"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

/// <reference types="webappsec-credential-management" />

import { ActionArgs } from 'xstate';
import { AnyActorContext } from 'xstate';
import { AnyActorRef } from 'xstate';
import { AnyEventObject } from 'xstate';
import { AnyState } from 'xstate';
import { Assigner } from 'xstate';
import { BindingObserver } from '@microsoft/fast-element';
import { Container } from '@microsoft/fast-foundation';
import { DelayExpr } from 'xstate';
import { DoneInvokeEvent } from 'xstate';
import { ErrorDetailMap } from '@genesislcap/foundation-utils';
import { ErrorEvent as ErrorEvent_2 } from 'xstate';
import { ErrorMap } from '@genesislcap/foundation-utils';
import { EventObject } from 'xstate';
import { ExecutionContext } from '@microsoft/fast-element';
import type { IBackoffFactory } from 'cockatiel';
import { ICancellationContext } from 'cockatiel';
import { IMergedPolicy } from 'cockatiel';
import { InterfaceSymbol } from '@microsoft/fast-foundation';
import type { InternalMachineImplementations } from 'xstate';
import type { InterpreterFrom } from 'xstate';
import type { InterpreterOptions } from 'xstate';
import type { IRetryBackoffContext } from 'cockatiel';
import { IRetryContext } from 'cockatiel';
import { Logger } from '@genesislcap/foundation-logger';
import { MachineContext as MachineContext_2 } from 'xstate';
import { Message } from '@genesislcap/foundation-comms';
import type { NoInfer } from 'xstate';
import { ParameterizedObject } from 'xstate';
import { PropertyAssigner } from 'xstate';
import type { ProvidedActor } from 'xstate';
import type { ResolveTypegenMeta } from 'xstate';
import { RetryPolicy } from 'cockatiel';
import { SendExpr } from 'xstate';
import type { State } from 'xstate';
import type { StateMachine } from 'xstate';
import type { StateNodeConfig } from 'xstate';
import type { StateValue } from 'xstate';
import type { StateValueFrom } from 'xstate';
import { StatusCodes } from 'http-status-codes';
import { TimeoutPolicy } from 'cockatiel';
import type { TypegenDisabled } from 'xstate';
import { UnifiedArg } from 'xstate';

// @public
export abstract class AbstractMachine<TContext extends MachineContext, TEvent extends EventObject = AnyEventObject, TAction extends ParameterizedObject = ParameterizedObject, TActor extends ProvidedActor = ProvidedActor, TInput = any, TResolvedTypesMeta = ResolveTypegenMeta<TypegenDisabled, NoInfer<TEvent>, TAction, TActor>> implements Machine<TContext, TEvent, TAction, TActor, TInput, TResolvedTypesMeta> {
    actor: InterpreterFrom<StateMachine<TContext, TEvent, TAction, TActor, TInput, TResolvedTypesMeta>>;
    // @internal (undocumented)
    protected applySnapshot(snapshot?: typeof AbstractMachine.snapshot): void;
    // Warning: (ae-incompatible-release-tags) The symbol "binding" is marked as @public, but its signature references "SubscriberChangeCallback" which is marked as @internal
    binding<TReturn = any, TParent = any>(token: ((target: this) => TReturn) | keyof this, subscriberChangeCallback?: SubscriberChangeCallback<TReturn> | undefined, isVolatileBinding?: boolean, context?: ExecutionContext): BindingObserver<this, TReturn, TParent>;
    complete: boolean;
    // @internal (undocumented)
    protected container: Container;
    context: Partial<TContext>;
    error: any;
    errors: ErrorMap<ErrorDetailMap>;
    abstract getFromContainer(): this;
    getMetaValuesByKey<T = string>(key?: string): T[];
    hasTag(tag: string): boolean;
    // @internal (undocumented)
    protected interpret(options?: InterpreterOptions<typeof AbstractMachine.machine>): void;
    machine: StateMachine<TContext, TEvent, TAction, TActor, TInput, TResolvedTypesMeta>;
    matches(value: StateValueFrom<typeof AbstractMachine.machine>): boolean;
    meta: Record<string, any>;
    onSendEvent: (event: CustomEvent<TEvent>) => void;
    output: any;
    provide(implementations: InternalMachineImplementations<TContext, TEvent, TAction, TActor, TResolvedTypesMeta, true>): void;
    send(event: TEvent): void;
    snapshot: State<TContext, TEvent, TActor, TResolvedTypesMeta>;
    start(options?: InterpreterOptions<typeof AbstractMachine.machine>): void;
    // @internal (undocumented)
    protected startActor(): void;
    startingContext: Partial<TContext>;
    startingState: StateValue;
    state: StateValue;
    stop(): void;
    // @internal (undocumented)
    protected stopActor(): void;
    // @internal (undocumented)
    protected subscribe(): void;
    // @internal (undocumented)
    protected unsubscribe(): void;
}

// @public
export class APIError extends Error {
    constructor(status: number, data?: unknown, message?: string);
    // (undocumented)
    data?: unknown;
    // (undocumented)
    isUnauthorized(): boolean;
    // (undocumented)
    status: number;
}

// @public
export function assertEvent<TEvent extends EventObject = EventObject>(event: TEvent, type: TEvent['type']): asserts event is Extract<TEvent, {
    type: TEvent['type'];
}>;

// @public
export const createErrorStateNode: (key: string, metaContent?: string, final?: boolean) => StateNodeConfig<any, any, any, any>;

// @public
export const createFetchPolicy: (maxAttempts?: number, retryCodes?: StatusCodes[] | number[], backoff?: IBackoffFactory<IRetryBackoffContext<unknown>>, timeoutDuration?: number, logEvents?: boolean) => IMergedPolicy<IRetryContext & ICancellationContext, never, [RetryPolicy, TimeoutPolicy]>;

// @public
export const createResponseDataExtractorWithDeserializer: <TInput = any, TOutput = any>(deserializer: (data: TInput) => Promise<TOutput>, extractor?: ResponseDataExtractor) => ResponseDataExtractor;

// @public
export const defaultFetchConfig: FetchConfig;

// @public
export class DefaultFetchMachine extends AbstractMachine<FetchMachineContext, FetchMachineEvent> implements FetchMachine {
    constructor(config?: FetchConfig);
    getFromContainer(): this;
    start(options?: InterpreterOptions<typeof DefaultFetchMachine.machine>): void;
}

// @public
export const defaultFetchMachineContext: Partial<FetchMachineContext>;

// @public
export const defaultFetchPolicy: IMergedPolicy<IRetryContext & ICancellationContext, never, [RetryPolicy, TimeoutPolicy]>;

// @public
export const defaultResponseDataExtractor: ResponseDataExtractor;

// @public
export const defaultResponseOkChecker: ResponseOkChecker;

// @public
export const defaultRetryStatsCodes: StatusCodes[];

// @public
export type ErrorWorkflowInput = {
    errorKey: string;
    errorValue: any;
    errorMap: ErrorMap<ErrorDetailMap>;
};

// @public
export const errorWorkflowInput: (key: string) => ({ context }: {
    context: any;
}) => ErrorWorkflowInput;

// @public
export const escalateError: {
    (_: ActionArgs<MachineContext_2, EventObject, ParameterizedObject>): void;
    type: string;
    to: string | AnyActorRef | ((args: UnifiedArg<MachineContext_2, EventObject>) => string | AnyActorRef);
    event: any;
    id: string;
    delay: string | number | DelayExpr<MachineContext_2, EventObject>;
    resolve: (actorContext: AnyActorContext, state: AnyState, args: ActionArgs<any, any, ParameterizedObject>, { to, event: eventOrExpr, id, delay }: {
        to: string | AnyActorRef | ((args: UnifiedArg<MachineContext_2, EventObject>) => string | AnyActorRef);
        event: EventObject | SendExpr<MachineContext_2, EventObject, EventObject>;
        id: string;
        delay: string | number | DelayExpr<MachineContext_2, EventObject>;
    }) => (AnyState | {
        to: AnyActorRef;
        event: EventObject;
        id: string;
        delay: number;
    })[];
    execute: (actorContext: AnyActorContext, params: {
        to: AnyActorRef;
        event: EventObject;
        id: string;
        delay: number;
    }) => void;
};

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "FetchConfig" because one of its declarations is marked as @internal
//
// @public
export interface FetchConfig {
    fetcher: typeof fetch;
    fetchPolicy?: IMergedPolicy<any, any, any>;
    responseDataExtractor?: ResponseDataExtractor;
    responseOkChecker?: ResponseOkChecker;
}

// @internal
export const FetchConfig: InterfaceSymbol<FetchConfig>;

// Warning: (ae-internal-mixed-release-tag) Mixed release tags are not allowed for "FetchMachine" because one of its declarations is marked as @internal
//
// @public
export interface FetchMachine extends Machine<FetchMachineContext, FetchMachineEvent> {
}

// @internal
export const FetchMachine: InterfaceSymbol<FetchMachine>;

// @public
export interface FetchMachineContext extends MachineContext {
    controller: AbortController;
    data: any;
    params: {
        url: string;
        requestInit?: RequestInit | CMRequestInit;
        fetchConfig?: FetchConfig;
    };
    response: Response | undefined;
}

// @public
export type FetchMachineEvent = {
    type: 'fetch';
    params: FetchMachineContext['params'];
} | {
    type: 'cancel';
} | DoneInvokeEvent<unknown> | ErrorEvent_2<unknown>;

// @public
export type FetchMachineEventMap = {
    'fetch-machine-event': FetchMachineEvent;
};

// @public
export type FetchMachineOutput<TData = any> = Partial<Pick<FetchMachineContext, 'response' | 'error'>> & {
    data: TData;
};

// @public
export class GenesisServerError extends Error {
    constructor(sent?: Message, received?: Message, message?: string);
    // (undocumented)
    getDetailsError(): string;
    // (undocumented)
    getMessageError(): string;
    // (undocumented)
    hasErrorCode(code: string): boolean;
    isIgnorableError(): boolean;
    // (undocumented)
    received?: Message;
    // (undocumented)
    sent?: Message;
}

// Warning: (ae-internal-missing-underscore) The name "getBindArgs" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export const getBindArgs: <TTarget = any>(...args: unknown[]) => TargetBinding<TTarget>;

// @public
export const isAbortError: ({ event }: {
    event: any;
}) => boolean;

// @public
export const isActorErrorEvent: <TData = any>(actorId: string, event: EventObject | ErrorEvent_2<TData>) => event is ErrorEvent_2<TData>;

// @public (undocumented)
export const isAPIError: (error: unknown) => error is APIError;

// @public
export const isDoneInvokeEvent: <TData = any>(event: EventObject | DoneInvokeEvent<TData>) => event is DoneInvokeEvent<TData>;

// @public
export const isErrorCustomEvent: <TData = any>(event: EventObject | ErrorEvent_2<TData>) => event is ErrorEvent_2<TData>;

// @public
export const isErrorEvent: <TData = any>(event: EventObject | ErrorEvent_2<TData>) => event is ErrorEvent_2<TData>;

// @public
export const isErrorType: <TType extends ErrorConstructor>(type: TType) => (event: any) => boolean;

// @public
export const isEventWithParams: (event: AnyEventObject) => event is ParameterizedObject;

// @public (undocumented)
export const isGenesisServerError: (error: unknown) => error is GenesisServerError;

// @public (undocumented)
export const isMappingError: (error: unknown) => error is MappingError;

// @public (undocumented)
export const isNetworkError: (error: unknown) => error is NetworkError;

// @public (undocumented)
export const isNotFoundError: (error: {
    status?: number;
}) => error is APIError;

// @public
export const isSyntaxError: ({ event }: {
    event: any;
}) => boolean;

// @public
export const isTypeError: ({ event }: {
    event: any;
}) => boolean;

// @public (undocumented)
export const isUnauthorizedError: (error: {
    status?: number;
}) => error is APIError;

// @public (undocumented)
export const logger: Logger;

// @public
export interface Machine<TContext extends MachineContext, TEvent extends EventObject = AnyEventObject, TAction extends ParameterizedObject = ParameterizedObject, TActor extends ProvidedActor = ProvidedActor, TInput = any, TResolvedTypesMeta = ResolveTypegenMeta<TypegenDisabled, NoInfer<TEvent>, TAction, TActor>> {
    readonly actor?: InterpreterFrom<StateMachine<TContext, TEvent, TAction, TActor, TInput, TResolvedTypesMeta>>;
    // Warning: (ae-incompatible-release-tags) The symbol "binding" is marked as @public, but its signature references "SubscriberChangeCallback" which is marked as @internal
    binding<TReturn = any, TParent = any>(token: ((target: this) => TReturn) | keyof this, subscriberChangeCallback?: SubscriberChangeCallback<TReturn> | undefined, isVolatileBinding?: boolean, context?: ExecutionContext): BindingObserver<this, TReturn, TParent>;
    readonly complete: boolean;
    readonly context: Partial<TContext>;
    readonly error: any;
    readonly errors: ErrorMap<ErrorDetailMap>;
    getFromContainer(): this;
    getMetaValuesByKey<T = string>(key?: string): T[];
    hasTag(tag: string): boolean;
    readonly machine: StateMachine<TContext, TEvent, TAction, TActor, TInput, TResolvedTypesMeta>;
    matches(value: StateValueFrom<StateMachine<TContext, TEvent, TAction, TActor, TInput, TResolvedTypesMeta>>): boolean;
    readonly meta: Record<string, any>;
    onSendEvent(event: CustomEvent<TEvent>): void;
    readonly output: any;
    provide(implementations: InternalMachineImplementations<TContext, TEvent, TAction, TActor, TResolvedTypesMeta, true>): void;
    send(event: TEvent): void;
    readonly snapshot: State<TContext, TEvent, TActor, TResolvedTypesMeta>;
    start(options?: InterpreterOptions<StateMachine<TContext, TEvent, TAction, TActor, TInput, TResolvedTypesMeta>>): any;
    readonly startingContext: Partial<TContext>;
    readonly startingState: StateValue;
    readonly state: StateValue;
    stop(): void;
}

// @public
export interface MachineContext extends MachineContext_2 {
    readonly error: any;
    readonly errors: ErrorMap<ErrorDetailMap>;
}

// @public
export class MappingError extends Error {
    constructor(dto?: unknown, message?: string);
    // (undocumented)
    dto?: unknown;
}

// @public
export class NetworkError extends Error {
    constructor(url: string, message?: string);
    // (undocumented)
    url: string;
}

// @public
export type ResponseDataExtractor<TData = any> = (response: Response) => Promise<TData>;

// @public
export type ResponseOkChecker = (response: Response) => boolean;

// @public
export const setError: {
    (_: ActionArgs<MachineContext_2, EventObject, ParameterizedObject>): void;
    type: string;
    assignment: Assigner<MachineContext_2, EventObject> | PropertyAssigner<MachineContext_2, EventObject>;
    resolve: (actorContext: AnyActorContext, state: AnyState, actionArgs: ActionArgs<any, any, ParameterizedObject>, { assignment }: {
        assignment: Assigner<any, any> | PropertyAssigner<any, any>;
    }) => AnyState[];
};

// @public
export const setErrorByKey: (key: string) => {
    (_: ActionArgs<MachineContext_2, EventObject, ParameterizedObject>): void;
    type: string;
    assignment: Assigner<MachineContext_2, EventObject> | PropertyAssigner<MachineContext_2, EventObject>;
    resolve: (actorContext: AnyActorContext, state: AnyState, actionArgs: ActionArgs<any, any, ParameterizedObject>, { assignment }: {
        assignment: Assigner<any, any> | PropertyAssigner<any, any>;
    }) => AnyState[];
};

// Warning: (ae-internal-missing-underscore) The name "SubscriberChangeCallback" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export type SubscriberChangeCallback<TReturn = any> = (value: TReturn, args: BindingObserver) => void;

// Warning: (ae-internal-missing-underscore) The name "SubscriberChangeHandler" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export type SubscriberChangeHandler<TTarget = any, TReturn = any> = (binding: (x?: TTarget, context?: ExecutionContext) => TReturn, args: BindingObserver) => void;

// Warning: (ae-internal-missing-underscore) The name "TargetBinding" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export type TargetBinding<TTarget = any> = (target: TTarget) => any;

// Warning: (ae-internal-missing-underscore) The name "TargetSubscriber" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export interface TargetSubscriber<TTarget = any, TReturn = any> {
    // (undocumented)
    handleChange: SubscriberChangeHandler<TTarget, TReturn>;
}

// (No @packageDocumentation comment for this package)

```
