<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-state-machine](./foundation-state-machine.md) &gt; [AbstractMachine](./foundation-state-machine.abstractmachine.md)

## AbstractMachine class

AbstractMachine base class.

**Signature:**

```typescript
export declare abstract class AbstractMachine<TContext extends MachineContext, TEvent extends EventObject = AnyEventObject, TAction extends ParameterizedObject = ParameterizedObject, TActor extends ProvidedActor = ProvidedActor, TInput = any, TResolvedTypesMeta = ResolveTypegenMeta<TypegenDisabled, NoInfer<TEvent>, TAction, TActor>> implements Machine<TContext, TEvent, TAction, TActor, TInput, TResolvedTypesMeta> 
```
**Implements:** [Machine](./foundation-state-machine.machine.md)<!-- -->&lt;TContext, TEvent, TAction, TActor, TInput, TResolvedTypesMeta&gt;

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  [actor](./foundation-state-machine.abstractmachine.actor.md) |  | InterpreterFrom&lt;StateMachine&lt;TContext, TEvent, TAction, TActor, TInput, TResolvedTypesMeta&gt;&gt; | Optional actor |
|  [complete](./foundation-state-machine.abstractmachine.complete.md) |  | boolean | Indicates if the machine has completed the happy path. |
|  [context](./foundation-state-machine.abstractmachine.context.md) |  | Partial&lt;TContext&gt; | The current <code>context</code> of the machine. The data points in context may be considered transient in nature. |
|  [error](./foundation-state-machine.abstractmachine.error.md) |  | any | A general machine error. Likely equal to <code>errors.lastError</code>. |
|  [errors](./foundation-state-machine.abstractmachine.errors.md) |  | ErrorMap&lt;ErrorDetailMap&gt; | An  of errors that may have occurred during the machine's workflows. |
|  [machine](./foundation-state-machine.abstractmachine.machine.md) |  | StateMachine&lt;TContext, TEvent, TAction, TActor, TInput, TResolvedTypesMeta&gt; | Mandatory machine property. |
|  [meta](./foundation-state-machine.abstractmachine.meta.md) |  | Record&lt;string, any&gt; | The <code>meta</code> from the current <code>state</code>. |
|  [onSendEvent](./foundation-state-machine.abstractmachine.onsendevent.md) |  | (event: CustomEvent&lt;TEvent&gt;) =&gt; void | A custom event handler to send events to the machine. |
|  [output](./foundation-state-machine.abstractmachine.output.md) |  | any | Holds successful machine output if any. |
|  [snapshot](./foundation-state-machine.abstractmachine.snapshot.md) |  | State&lt;TContext, TEvent, TActor, TResolvedTypesMeta&gt; | The last <code>snapshot</code> from the actor. |
|  [startingContext](./foundation-state-machine.abstractmachine.startingcontext.md) |  | Partial&lt;TContext&gt; | The <code>context</code> of the machine when started. |
|  [startingState](./foundation-state-machine.abstractmachine.startingstate.md) |  | StateValue | The <code>state</code> of the machine when started. Allows consumers to start a machine from a persisted state. |
|  [state](./foundation-state-machine.abstractmachine.state.md) |  | StateValue | The current <code>state</code> of the machine itself. This is not to be confused with state in the data or store sense. |

## Methods

|  Method | Modifiers | Description |
|  --- | --- | --- |
|  [binding(token, subscriberChangeCallback, isVolatileBinding, context)](./foundation-state-machine.abstractmachine.binding.md) |  | An api to allow the observation of values and arbitrary bindings outside the template engine. |
|  [getFromContainer()](./foundation-state-machine.abstractmachine.getfromcontainer.md) | <code>abstract</code> | Gets the machine from the container. |
|  [getMetaValuesByKey(key)](./foundation-state-machine.abstractmachine.getmetavaluesbykey.md) |  | Get <code>meta</code> values by key. |
|  [hasTag(tag)](./foundation-state-machine.abstractmachine.hastag.md) |  | Check <code>tags</code> contain provided tag. |
|  [matches(value)](./foundation-state-machine.abstractmachine.matches.md) |  | Check <code>state</code> matches provided value. |
|  [provide(implementations)](./foundation-state-machine.abstractmachine.provide.md) |  | Recreate the internal machine with the provided implementations. |
|  [send(event)](./foundation-state-machine.abstractmachine.send.md) |  | An api to send events to the machine. |
|  [start(options)](./foundation-state-machine.abstractmachine.start.md) |  | Start the machine. |
|  [stop()](./foundation-state-machine.abstractmachine.stop.md) |  | Stop the machine. |

