<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-state-machine](./foundation-state-machine.md) &gt; [Machine](./foundation-state-machine.machine.md) &gt; [binding](./foundation-state-machine.machine.binding.md)

## Machine.binding() method

An api to allow the observation of values and arbitrary bindings outside the template engine.

**Signature:**

```typescript
binding<TReturn = any, TParent = any>(token: ((target: this) => TReturn) | keyof this, subscriberChangeCallback?: SubscriberChangeCallback<TReturn> | undefined, isVolatileBinding?: boolean, context?: ExecutionContext): BindingObserver<this, TReturn, TParent>;
```

## Parameters

|  Parameter | Type | Description |
|  --- | --- | --- |
|  token | ((target: this) =&gt; TReturn) \| keyof this | A target lookup token which can take various forms. |
|  subscriberChangeCallback | SubscriberChangeCallback&lt;TReturn&gt; \| undefined | _(Optional)_ . |
|  isVolatileBinding | boolean | _(Optional)_ Indicates the binding is volatile. |
|  context | ExecutionContext | _(Optional)_ . |

**Returns:**

BindingObserver&lt;this, TReturn, TParent&gt;

## Example 1

TS attains the value type information from the machine's interface.

```ts
this.myMachine.binding(x => x.context.data, value => {...}); // value is typeof data
```

## Example 2

You can also use the underlying BindingObserver api should you prefer.

```ts
this.myMachine.binding(x => x.error).subscribe({
  handleChange(binding, args) {
    ...
  }
})
```

