<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-state-machine](./foundation-state-machine.md) &gt; [Machine](./foundation-state-machine.machine.md) &gt; [getFromContainer](./foundation-state-machine.machine.getfromcontainer.md)

## Machine.getFromContainer() method

Gets the machine from the container.

**Signature:**

```typescript
getFromContainer(): this;
```
**Returns:**

this

## Remarks

Calling `getFromContainer` on an injected machine will return a new instance providing it was registered with the DI as `transient`<!-- -->. This is simply a convenience method, and may be useful as some machines contain 'final' states, meaning once they complete they can no longer receive events. However, if you want to continue to work with your injected machine reference, re-calling [start](./foundation-state-machine.machine.start.md) may also be a viable option.

Please note that machines are injected into other machines to form parts of complex workflows. In such cases, the parent machine will `invoke` or `spawn` the injected machine's `logic` directly to always create a new actor.

## Example

Invoke an injected machine's `logic` from a parent machine

```ts
invoke: {
   id: 'dataFetcher',
   src: fetchMachine.machine, // < Or `src: 'fetcher'`, and create that actor to interact with the injected machine.
   ...
}
```

