<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-state-machine](./foundation-state-machine.md) &gt; [Machine](./foundation-state-machine.machine.md) &gt; [provide](./foundation-state-machine.machine.provide.md)

## Machine.provide() method

Recreate the internal machine with the provided implementations.

**Signature:**

```typescript
provide(implementations: InternalMachineImplementations<TContext, TEvent, TAction, TActor, TResolvedTypesMeta, true>): void;
```

## Parameters

|  Parameter | Type | Description |
|  --- | --- | --- |
|  implementations | InternalMachineImplementations&lt;TContext, TEvent, TAction, TActor, TResolvedTypesMeta, true&gt; | <code>actions</code>, <code>guards</code>, <code>actors</code>... to merge with existing options. |

**Returns:**

void

## Example

Using an existing machine with a custom implementation.

```ts
@MyMachine readonly machine: MyMachine;
...
this.machine.provide({
  actors: {
    serviceCallX: fromPromise(async ({ input }) => Promise.resolve(new Error('Overridden serviceCallX'))),
    onSuccess: (context) => successHandlerInHost(context.data)
  },
  guards: {
    isAssured: ({ context }) => true,
  },
});
// When you change the machine it will stop if running, so you'll have to call {@link Machine.start | start} again.
this.machine.start();
```

